# -*- coding: utf-8 -*-
#
# Copyright (c) 2020, HILSTER GmbH, Germany - https://hilster.io
# All rights reserved.
#

from __future__ import absolute_import, division, print_function, unicode_literals


class FeatureLocked(Exception):
    """
    A requested feature is locked
    """


class DelegationError(Exception):
    """
    ``DelegationError`` is thrown if :class:`DelegateMixin` is used directly without being mixed in.
    """


class SkipTest(Exception):
    pass


class SkipStep(SkipTest):
    pass


class RepeatTest(SkipTest):
    pass


class ParsingError(BaseException):
    pass


class NotRunException(Exception):
    pass


class ScheduledException(Exception):
    pass


class ThreadExit(BaseException):
    pass


class CancelTestException(AssertionError):
    pass
