# -*- coding: utf-8 -*-
#
# Copyright (c) 2020, HILSTER GmbH, Germany - https://hilster.io
# All rights reserved.
#
# This file was generated by wrappergenerator.py
#

from __future__ import absolute_import, division, print_function, unicode_literals

from htf.core import filter_and as _filter_and
from htf.core import filter_nand as _filter_nand
from htf.core import filter_nor as _filter_nor
from htf.core import filter_not as _filter_not
from htf.core import filter_or as _filter_or
from htf.core import filter_xnor as _filter_xnor
from htf.core import filter_xor as _filter_xor


def filter_and(*filters):
    """
    Create a filter that combines all results or values of ``*filters`` using logical and.

    Args:
        *filters (tuple): a tuple of filters.

    Returns:
        callable: a filter that combines all elements in ``*filters`` using logical and.
    """
    return _filter_and(*filters)


filterAnd = filter_and


def filter_nand(*filters):
    """
    Create a filter that combines all results or values of ``*filters`` using logical nand.

    Args:
        *filters (tuple): a tuple of filters.

    Returns:
        callable: a filter that combines all elements in ``*filters`` using logical nand.
    """
    return _filter_nand(*filters)


filterNand = filter_nand


def filter_nor(*filters):
    """
    Create a filter that combines all results or values of ``*filters`` using logical nor.

    Args:
        *filters (tuple): a tuple of filters.

    Returns:
        callable: a filter that combines all elements in ``*filters`` using logical nor.
    """
    return _filter_nor(*filters)


filterNor = filter_nor


def filter_not(filter_method):
    """
    Create a filter that inverts ``filter_method``'s result or values.

    Args:
        filter_method (callable): the filter that is inverted.

    Returns:
        callable: a filter that inverts ``filter_method``.
    """
    return _filter_not(filter_method=filter_method)


filterNot = filter_not


def filter_or(*filters):
    """
    Create a filter that combines all results or values of ``*filters`` using or-logic.

    Args:
        *filters (tuple): a tuple of filters.

    Returns:
        callable: a filter that conjuncts all elements in ``*filters``.
    """
    return _filter_or(*filters)


filterOr = filter_or


def filter_xnor(*filters):
    """
    Create a filter that combines all results or values of ``*filters`` using logical xnor.

    Args:
        *filters (tuple): a tuple of filters.

    Returns:
        callable: a filter that combines all elements in ``*filters`` using logical xnor.
    """
    return _filter_xnor(*filters)


filterXnor = filter_xnor


def filter_xor(*filters):
    """
    Create a filter that combines all results or values of ``*filters`` using xor-logic.

    Args:
        *filters (tuple): a tuple of filters.

    Returns:
        callable: a filter that xors all elements in ``*filters``.
    """
    return _filter_xor(*filters)


filterXor = filter_xor


