# -*- coding: utf-8 -*-
#
# Copyright (c) 2016, HILSTER GmbH, Germany - http://hilster.de
# All rights reserved.
#
# This file was generated by wrappergenerator.py
#

from __future__ import absolute_import, division, print_function, unicode_literals

from htf.powersupply._rs_hmpseries import HMP2020 as _HMP2020
from htf.powersupply._rs_hmpseries import HMP2030 as _HMP2030
from htf.powersupply._rs_hmpseries import HMP4030 as _HMP4030
from htf.powersupply._rs_hmpseries import HMP4040 as _HMP4040


class HMP2020(_HMP2020):
    """
    HMP2020: 1 × 0 V to 32 V/0 A to 10 A; 1 × 0 V to 32 V/0 A to 5 A (188 W)
    """

    def __init__(self, comport, baudrate=9600, parity='N', stopbits=1, timeout=1.0, command_delay=0.05, wait_after_set_voltage=False, wait_time=0.5):
        """
        Initialize self.  See help(type(self)) for accurate signature.
        """
        super(HMP2020, self).__init__(comport=comport, baudrate=baudrate, parity=parity, stopbits=stopbits, timeout=timeout, command_delay=command_delay, wait_after_set_voltage=wait_after_set_voltage, wait_time=wait_time)

    def close(self):
        """
        Close serial connection.
        """
        return super(HMP2020, self).close()

    def disable_general_output(self):
        """
        Enable the general output.
        """
        return super(HMP2020, self).disable_general_output()

    def disable_output(self):
        """
        Disable the output of the currently selected channel.
        """
        return super(HMP2020, self).disable_output()

    def enable_general_output(self):
        """
        Enable the general output.
        """
        return super(HMP2020, self).enable_general_output()

    def enable_output(self):
        """
        Enable the output of the currently selected channel.
        """
        return super(HMP2020, self).enable_output()

    def get_actual_current(self):
        """
        Get the measured current of the currently selected channel.

        Returns:
            float: the measured current of the currently selected channel
        """
        return super(HMP2020, self).get_actual_current()

    def get_actual_voltage(self):
        """
        Get the measured voltage of the currently selected channel.

        Returns:
            float: the measured voltage of the currently selected channel
        """
        return super(HMP2020, self).get_actual_voltage()

    def get_current(self):
        """
        Get the current of the currently selected channel.

        Returns:
            float: the current of the currently selected channel
        """
        return super(HMP2020, self).get_current()

    def get_idn(self):
        """
        Get the identifier.

        Returns:
            str: the identifier of the device
        """
        return super(HMP2020, self).get_idn()

    def get_voltage(self):
        """
        Get the voltage of the currently selected channel.

        Returns:
            float: the voltage of the currently selected channel
        """
        return super(HMP2020, self).get_voltage()

    def recall_state(self, location):
        """
        Recall the instrument state from the specified storage location.

        Args:
            location (int): the storage location to load the instrument state from.
        """
        return super(HMP2020, self).recall_state(location=location)

    def select_channel(self, channel):
        """
        Select a channel.

        Args:
            channel (int): the channel to be selected (``1 .. 4``)
        """
        return super(HMP2020, self).select_channel(channel=channel)

    def select_output_channel(self):
        """
        Disable currently selected channel for general output.
        """
        return super(HMP2020, self).select_output_channel()

    def deselect_output_channel(self):
        """
        Deselect currently selected channel for general output.
        """
        return super(HMP2020, self).deselect_output_channel()

    def set_current(self, current, read_back=True):
        """
        Set the current of the currently selected channel

        Args:
            current (float): the current to be set
            read_back=True (bool): if True the set current is read back and compared to the expected current
        """
        return super(HMP2020, self).set_current(current=current, read_back=read_back)

    def set_voltage(self, voltage, auto_enable=False):
        """
        Set the volate on the currently selected channel.

        Args:
            volate (float): the voltage to be set.
            auto_enable=False (bool): if set to ``True`` the output is enabled automatically.
        """
        return super(HMP2020, self).set_voltage(voltage=voltage, auto_enable=auto_enable)

    def store_state(self, location):
        """
        Save the current instrument state to the specified storage location.

        Args:
            location (int): the storage location to store the instrument state to.
        """
        return super(HMP2020, self).store_state(location=location)



class HMP2030(_HMP2030):
    """
    HMP2030: 3 × 0 V to 32 V/0 A to 5 A (188 W)
    """

    def __init__(self, comport, baudrate=9600, parity='N', stopbits=1, timeout=1.0, command_delay=0.05, wait_after_set_voltage=False, wait_time=0.5):
        """
        Initialize self.  See help(type(self)) for accurate signature.
        """
        super(HMP2030, self).__init__(comport=comport, baudrate=baudrate, parity=parity, stopbits=stopbits, timeout=timeout, command_delay=command_delay, wait_after_set_voltage=wait_after_set_voltage, wait_time=wait_time)

    def close(self):
        """
        Close serial connection.
        """
        return super(HMP2030, self).close()

    def disable_general_output(self):
        """
        Enable the general output.
        """
        return super(HMP2030, self).disable_general_output()

    def disable_output(self):
        """
        Disable the output of the currently selected channel.
        """
        return super(HMP2030, self).disable_output()

    def enable_general_output(self):
        """
        Enable the general output.
        """
        return super(HMP2030, self).enable_general_output()

    def enable_output(self):
        """
        Enable the output of the currently selected channel.
        """
        return super(HMP2030, self).enable_output()

    def get_actual_current(self):
        """
        Get the measured current of the currently selected channel.

        Returns:
            float: the measured current of the currently selected channel
        """
        return super(HMP2030, self).get_actual_current()

    def get_actual_voltage(self):
        """
        Get the measured voltage of the currently selected channel.

        Returns:
            float: the measured voltage of the currently selected channel
        """
        return super(HMP2030, self).get_actual_voltage()

    def get_current(self):
        """
        Get the current of the currently selected channel.

        Returns:
            float: the current of the currently selected channel
        """
        return super(HMP2030, self).get_current()

    def get_idn(self):
        """
        Get the identifier.

        Returns:
            str: the identifier of the device
        """
        return super(HMP2030, self).get_idn()

    def get_voltage(self):
        """
        Get the voltage of the currently selected channel.

        Returns:
            float: the voltage of the currently selected channel
        """
        return super(HMP2030, self).get_voltage()

    def recall_state(self, location):
        """
        Recall the instrument state from the specified storage location.

        Args:
            location (int): the storage location to load the instrument state from.
        """
        return super(HMP2030, self).recall_state(location=location)

    def select_channel(self, channel):
        """
        Select a channel.

        Args:
            channel (int): the channel to be selected (``1 .. 4``)
        """
        return super(HMP2030, self).select_channel(channel=channel)

    def select_output_channel(self):
        """
        Select currently selected channel for general output.
        """
        return super(HMP2030, self).select_output_channel()

    def deselect_output_channel(self):
        """
        Deselect currently selected channel for general output.
        """
        return super(HMP2030, self).deselect_output_channel()

    def set_current(self, current, read_back=True):
        """
        Set the current of the currently selected channel

        Args:
            current (float): the current to be set
            read_back=True (bool): if True the set current is read back and compared to the expected current
        """
        return super(HMP2030, self).set_current(current=current, read_back=read_back)

    def set_voltage(self, voltage, auto_enable=False):
        """
        Set the volate on the currently selected channel.

        Args:
            volate (float): the voltage to be set.
            auto_enable=False (bool): if set to ``True`` the output is enabled automatically.
        """
        return super(HMP2030, self).set_voltage(voltage=voltage, auto_enable=auto_enable)

    def store_state(self, location):
        """
        Save the current instrument state to the specified storage location.

        Args:
            location (int): the storage location to store the instrument state to.
        """
        return super(HMP2030, self).store_state(location=location)



class HMP4030(_HMP4030):
    """
    HMP4030: 3 × 0 V to 32 V/0 A to 10 A (384 W)
    """

    def __init__(self, comport, baudrate=9600, parity='N', stopbits=1, timeout=1.0, command_delay=0.05, wait_after_set_voltage=False, wait_time=0.5):
        """
        Initialize self.  See help(type(self)) for accurate signature.
        """
        super(HMP4030, self).__init__(comport=comport, baudrate=baudrate, parity=parity, stopbits=stopbits, timeout=timeout, command_delay=command_delay, wait_after_set_voltage=wait_after_set_voltage, wait_time=wait_time)

    def close(self):
        """
        Close serial connection.
        """
        return super(HMP4030, self).close()

    def disable_general_output(self):
        """
        Enable the general output.
        """
        return super(HMP4030, self).disable_general_output()

    def disable_output(self):
        """
        Disable the output of the currently selected channel.
        """
        return super(HMP4030, self).disable_output()

    def enable_general_output(self):
        """
        Enable the general output.
        """
        return super(HMP4030, self).enable_general_output()

    def enable_output(self):
        """
        Enable the output of the currently selected channel.
        """
        return super(HMP4030, self).enable_output()

    def get_actual_current(self):
        """
        Get the measured current of the currently selected channel.

        Returns:
            float: the measured current of the currently selected channel
        """
        return super(HMP4030, self).get_actual_current()

    def get_actual_voltage(self):
        """
        Get the measured voltage of the currently selected channel.

        Returns:
            float: the measured voltage of the currently selected channel
        """
        return super(HMP4030, self).get_actual_voltage()

    def get_current(self):
        """
        Get the current of the currently selected channel.

        Returns:
            float: the current of the currently selected channel
        """
        return super(HMP4030, self).get_current()

    def get_idn(self):
        """
        Get the identifier.

        Returns:
            str: the identifier of the device
        """
        return super(HMP4030, self).get_idn()

    def get_voltage(self):
        """
        Get the voltage of the currently selected channel.

        Returns:
            float: the voltage of the currently selected channel
        """
        return super(HMP4030, self).get_voltage()

    def recall_state(self, location):
        """
        Recall the instrument state from the specified storage location.

        Args:
            location (int): the storage location to load the instrument state from.
        """
        return super(HMP4030, self).recall_state(location=location)

    def select_channel(self, channel):
        """
        Select a channel.

        Args:
            channel (int): the channel to be selected (``1 .. 4``)
        """
        return super(HMP4030, self).select_channel(channel=channel)

    def select_output_channel(self):
        """
        Select currently selected channel for general output.
        """
        return super(HMP4030, self).select_output_channel()

    def deselect_output_channel(self):
        """
        Deselect currently selected channel for general output.
        """
        return super(HMP4030, self).deselect_output_channel()

    def set_current(self, current, read_back=True):
        """
        Set the current of the currently selected channel

        Args:
            current (float): the current to be set
            read_back=True (bool): if True the set current is read back and compared to the expected current
        """
        return super(HMP4030, self).set_current(current=current, read_back=read_back)

    def set_voltage(self, voltage, auto_enable=False):
        """
        Set the volate on the currently selected channel.

        Args:
            volate (float): the voltage to be set.
            auto_enable=False (bool): if set to ``True`` the output is enabled automatically.
        """
        return super(HMP4030, self).set_voltage(voltage=voltage, auto_enable=auto_enable)

    def store_state(self, location):
        """
        Save the current instrument state to the specified storage location.

        Args:
            location (int): the storage location to store the instrument state to.
        """
        return super(HMP4030, self).store_state(location=location)



class HMP4040(_HMP4040):
    """
    HMP4040: 4 × 0 V to 32 V/0 A to 10 A (384 W)
    """

    def __init__(self, comport, baudrate=9600, parity='N', stopbits=1, timeout=1.0, command_delay=0.05, wait_after_set_voltage=False, wait_time=0.5):
        """
        Initialize self.  See help(type(self)) for accurate signature.
        """
        super(HMP4040, self).__init__(comport=comport, baudrate=baudrate, parity=parity, stopbits=stopbits, timeout=timeout, command_delay=command_delay, wait_after_set_voltage=wait_after_set_voltage, wait_time=wait_time)

    def close(self):
        """
        Close serial connection.
        """
        return super(HMP4040, self).close()

    def disable_general_output(self):
        """
        Enable the general output.
        """
        return super(HMP4040, self).disable_general_output()

    def disable_output(self):
        """
        Disable the output of the currently selected channel.
        """
        return super(HMP4040, self).disable_output()

    def enable_general_output(self):
        """
        Enable the general output.
        """
        return super(HMP4040, self).enable_general_output()

    def enable_output(self):
        """
        Enable the output of the currently selected channel.
        """
        return super(HMP4040, self).enable_output()

    def get_actual_current(self):
        """
        Get the measured current of the currently selected channel.

        Returns:
            float: the measured current of the currently selected channel
        """
        return super(HMP4040, self).get_actual_current()

    def get_actual_voltage(self):
        """
        Get the measured voltage of the currently selected channel.

        Returns:
            float: the measured voltage of the currently selected channel
        """
        return super(HMP4040, self).get_actual_voltage()

    def get_current(self):
        """
        Get the current of the currently selected channel.

        Returns:
            float: the current of the currently selected channel
        """
        return super(HMP4040, self).get_current()

    def get_idn(self):
        """
        Get the identifier.

        Returns:
            str: the identifier of the device
        """
        return super(HMP4040, self).get_idn()

    def get_voltage(self):
        """
        Get the voltage of the currently selected channel.

        Returns:
            float: the voltage of the currently selected channel
        """
        return super(HMP4040, self).get_voltage()

    def recall_state(self, location):
        """
        Recall the instrument state from the specified storage location.

        Args:
            location (int): the storage location to load the instrument state from.
        """
        return super(HMP4040, self).recall_state(location=location)

    def select_channel(self, channel):
        """
        Select a channel.

        Args:
            channel (int): the channel to be selected (``1 .. 4``)
        """
        return super(HMP4040, self).select_channel(channel=channel)

    def select_output_channel(self):
        """
        Select currently selected channel for general output.
        """
        return super(HMP4040, self).select_output_channel()

    def deselect_output_channel(self):
        """
        Deselect currently selected channel for general output.
        """
        return super(HMP4040, self).deselect_output_channel()

    def set_current(self, current, read_back=True):
        """
        Set the current of the currently selected channel

        Args:
            current (float): the current to be set
            read_back=True (bool): if True the set current is read back and compared to the expected current
        """
        return super(HMP4040, self).set_current(current=current, read_back=read_back)

    def set_voltage(self, voltage, auto_enable=False):
        """
        Set the volate on the currently selected channel.

        Args:
            volate (float): the voltage to be set.
            auto_enable=False (bool): if set to ``True`` the output is enabled automatically.
        """
        return super(HMP4040, self).set_voltage(voltage=voltage, auto_enable=auto_enable)

    def store_state(self, location):
        """
        Save the current instrument state to the specified storage location.

        Args:
            location (int): the storage location to store the instrument state to.
        """
        return super(HMP4040, self).store_state(location=location)

